/* Copyright (c) 2010 Vinay Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.google.gwt.maps.client.base.impl;

import com.google.gwt.core.client.GWT;
import com.google.gwt.core.client.JavaScriptObject;
import com.google.gwt.jsio.client.Constructor;
import com.google.gwt.jsio.client.JSFlyweightWrapper;

/**
 * @author vinay.sekhri@gmail.com (Vinay Sekhri)
 */
public interface InfoWindowImpl extends JSFlyweightWrapper {
  
  public InfoWindowImpl impl = GWT.create(InfoWindowImpl.class);
  
  @Constructor("$wnd.google.maps.InfoWindow")
  public JavaScriptObject construct();
  
  @Constructor("$wnd.google.maps.InfoWindow")
  public JavaScriptObject construct(JavaScriptObject options);
  
  void open(JavaScriptObject jso, JavaScriptObject map, JavaScriptObject anchor);

  public void close(JavaScriptObject jso);
  
  public String getContent(JavaScriptObject jso);
  
  public JavaScriptObject getPosition(JavaScriptObject jso);
  
  public int getZIndex(JavaScriptObject jso);
  
  public void setContent(JavaScriptObject jso, String html);
  
  public void setOptions(JavaScriptObject jso, JavaScriptObject options);
  
  public void setPosition(JavaScriptObject jso, JavaScriptObject position);
  
  public void setZIndex(JavaScriptObject jso, int zIndex);

}
