/* Copyright (c) 2010 Vinay Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.google.gwt.maps.client.directions;

import java.util.ArrayList;
import java.util.List;

import com.google.gwt.core.client.JavaScriptObject;
import com.google.gwt.maps.client.directions.impl.DirectionsResultImpl;

public class DirectionsResult implements HasDirectionsResult {

  final private JavaScriptObject jso;
  
  public DirectionsResult(final JavaScriptObject jso) {
    this.jso = jso;
  }

  @Override
  public List<HasDirectionsRoute> getRoutes() {
    List<HasDirectionsRoute> routes = new ArrayList<HasDirectionsRoute>();
    for (JavaScriptObject js : DirectionsResultImpl.impl.getRoutes(jso)) {
      routes.add(new DirectionsRoute(js));
    }
    return routes;
  }

  @Override
  public JavaScriptObject getJso() {
    return jso;
  }

}
